      SUBROUTINE SMFFT2(L2,L1,LV,EW2,EW1,AM2,AM1,CPL,
     $     F0,F1,F2,AMW,CE2,CE1,PS2,PS1,EP,Q,LT,AV)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (ZERO = 0.0D0, ONE = 1.0D0)
*     * dummy array size.
      PARAMETER (LTSIZE=20,LASIZE = 1024)
      INTEGER    L1, L2, LV
      DIMENSION  EW1(1), EW2(1)

      COMPLEX*16 CPL(2)
      COMPLEX*16 CE1(2,L1), CE2(2,L2)
      DIMENSION  PS1(4,3), PS2(4,3)

      DIMENSION  Q(4),EP(4,LV)
      COMPLEX*16 AV(0:LASIZE)

      INTEGER    LT(0:LTSIZE)
      DOUBLE PRECISION AL,AR

      DOUBLE PRECISION F0,F1,F2,AMW
      DOUBLE PRECISION FF0,FF1,FF2

      COMPLEX*16 AVT(4,2,2,2,2),AVT1(4,2,2,2,2),AVT2(4,2,2,2,2),CPN
      DIMENSION     CPR(2)

      DIMENSION  P0(4)
      DATA P0/4*ZERO/, AM0/ZERO/

*--------------------------- Entry point -------------------------------
      IF( CPL(1) .NE. ZERO) THEN
          CPN      = CPL(1)
          CPR(1) = ONE
          CPR(2) = CPL(2)/CPL(1)
      ELSEIF( CPL(2).NE.ZERO) THEN
          CPN      = CPL(2)
          CPR(2) = ONE
          CPR(1) = CPL(1)/CPL(2)
      ELSE
          CPN      = ZERO
          CPR(1) = ONE
          CPR(2) = ONE
      ENDIF

      IF(EW1(1).GE.ZERO) THEN
         K1 = 3
      ELSE
         K1 = 1
      ENDIF
      IF(EW2(1).GE.ZERO) THEN
         K2 = 3
      ELSE
         K2 = 1
      ENDIF

      FF0 = F0
      FF2 = F2
      IF (K1.EQ.3) THEN
         FF1 = F1
         AL = CPR(2)
         AR = CPR(1)
      ELSE
         FF1 = -F1
         AL = CPR(1)
         AR = CPR(2)
      ENDIF

      LT(0) =  3
      LT(1) =  L2
      LT(2) =  L1
      LT(3) =  LV
      DO LP = 1, LV
         CALL FFV(LP,K1,K2,AM1,AM2,CPR(1),CPR(2),CE1(1,2),CE2(1,1),
     $        PS1(1,1),PS1(1,2),PS2(1,1),PS2(1,2),EP(1,LP),
     $        AVT1(1,1,1,1,1))

         CALL FFTT(LP,K1,K2,AM1,AM2,AL,AR,CE1(1,2),CE2(1,1),
     $        PS1(1,1),PS1(1,2),PS2(1,1),PS2(1,2),EP(1,LP),Q,
     $        AVT2(1,1,1,1,1))

         DO J1 = 1,2
            DO J2 = 1,2
               AVT(LP,J1,J2,1,1) = FF0*AVT1(LP,J1,J2,1,1)
     $              +FF1*AVT2(LP,J1,J2,1,1)/AMW
            ENDDO
         ENDDO

      ENDDO
      IF (L1.EQ.4) THEN
         DO LP = 1, LV
            CALL FFV(LP,3,K2,AM0,AM2,CPR(1),CPR(2),CE1(1,4),CE2(1,1),
     $           PS1(1,3),P0,PS2(1,1),PS2(1,2),EP(1,LP),
     $           AVT1(1,1,1,2,1))

            CALL FFTT(LP,3,K2,AM0,AM2,AL,AR,CE1(1,4),
     $           CE2(1,1),PS1(1,3),P0,PS2(1,1),PS2(1,2),EP(1,LP),Q,
     $           AVT2(1,1,1,2,1))

            DO J1 = 1,2
               DO J2 = 1,2
                  AVT(LP,J1,J2,2,1) = FF0*AVT1(LP,J1,J2,2,1)
     $                 +FF1*AVT2(LP,J1,J2,2,1)/AMW
               ENDDO
            ENDDO

         ENDDO
      ENDIF
      IF (L2.EQ.4) THEN
         DO LP = 1, LV
            CALL FFV(LP,K1,3,AM1,AM0,CPR(1),CPR(2),CE1(1,2),CE2(1,3),
     $           PS1(1,1),PS1(1,2),PS2(1,3),P0,EP(1,LP),
     $           AVT1(1,1,1,1,2))

            CALL FFTT(LP,K1,3,AM1,AM0,AL,AR,CE1(1,2),
     $           CE2(1,3),PS1(1,1),PS1(1,2),PS2(1,3),P0,EP(1,LP),Q,
     $           AVT2(1,1,1,1,2))

            DO J1 = 1,2
               DO J2 = 1,2
                  AVT(LP,J1,J2,1,2) = FF0*AVT1(LP,J1,J2,1,2)
     $                 +FF1*AVT2(LP,J1,J2,1,2)/AMW
               ENDDO
            ENDDO

         ENDDO
      ENDIF
      IF (L1.EQ.4.AND.L2.EQ.4) THEN
         DO LP = 1, LV
            CALL FFV(LP,3,3,AM0,AM0,CPR(1),CPR(2),CE1(1,4),CE2(1,3),
     $           PS1(1,3),P0,PS2(1,3),P0,EP(1,LP),
     $           AVT1(1,1,1,2,2))

            CALL FFTT(LP,3,3,AM0,AM0,AL,AR,CE1(1,4),
     $           CE2(1,3),PS1(1,3),P0,PS2(1,3),P0,EP(1,LP),Q,
     $           AVT2(1,1,1,2,2))

            DO J1 = 1,2
               DO J2 = 1,2
                  AVT(LP,J1,J2,2,2) = FF0*AVT1(LP,J1,J2,2,2)
     $                 +FF1*AVT2(LP,J1,J2,2,2)/AMW
               ENDDO
            ENDDO

         ENDDO
      ENDIF

      IA = 0
      DO 500 IL  = 1, LV
      DO 500 IP1 = 1, L1/2
      DO 500 IL1 = 1, 2
      DO 500 IP2 = 1, L2/2
      DO 500 IL2 = 1, 2
         AV(IA) = CPN*AVT(IL, IL1, IL2, IP1, IP2)
         IA = IA + 1
*        print *,'smffv i,l,p1,l1,p2,l2',ia,il,ip1,il1,ip2,il2,
*    *    AVT1(IL, IL1, IL2, IP1, IP2)
  500 CONTINUE

      RETURN
      END
