      SUBROUTINE lhaReadEvnt( lunctl, lundat, ifmt, * )

C  Read one event from a file.
C  Try to open a new file if the end-of-file is detected.
C  The header information of the new file is ignored.
C  Return 1, if there is no more file to read.
C  June 4, 2004, S. Odaka (KEK)

      IMPLICIT NONE

      integer lunctl,lundat,ifmt

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Read an event record.
 1    continue
      if( ifmt.eq.0 ) then
         call lhaReadEvAsc(lundat,*8)
      elseif( ifmt.eq.1 ) then
         call lhaReadEvBin(lundat,*8)
      endif
      return

C  End of file.
 8    continue
C  Open the next file.
      print *,' '
      print *,'============================== lhaReadEvnt ',
     >     '=================================='
      print *,'End of file -> try to open the next file'
      close( lundat )
      call lhaopen( lunctl, lundat, ifmt, *9 )
C  Dummy read of the header.
      print *,'Read the header record (dummy read)'
      if( ifmt.eq.0 ) then
         call lhaReadHdAsc( lundat, 3 )
      elseif( ifmt.eq.1 ) then
         call lhaReadHdBin( lundat, 3 )
      endif
      print *,'===========================================',
     >     '=================================='
      goto 1

C  No more file to read.
 9    continue
      print *,'No more data file to read'
      print *,'===========================================',
     >     '=================================='
      return 1

      END
