      subroutine lhaWritEvAsc(lun)
      implicit none

C  Write the event data in the LHA external event interface common into 
C  a file (LUN = "lun") in an ASCII format.
C  The data can be read back using "lhaReadEvAsc".
C  May 6, 2004, S. Odaka (KEK)
C
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      integer lun,i,j

C  Event header
      write(lun,100) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP

C  Particle data
      do i=1,NUP
         write(lun,101) IDUP(i),ISTUP(i),(MOTHUP(j,i),j=1,2),
     >        (ICOLUP(j,i),j=1,2),(PUP(j,i),j=1,5),VTIMUP(i),SPINUP(i)
      enddo

 100  format(2I6,4E15.7)
 101  format(6I6,7E15.7)

      return
      end
      subroutine lhaWritEvBin(lun)
      implicit none

C  Write the event data in the LHA external event interface common into 
C  a file (LUN = "lun") as an unformatted binary record.
C  The data can be read back using "lhaReadEvBin".
C  May 6, 2004, S. Odaka (KEK)
C
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      integer lun,i,j

      write(lun) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     >     (IDUP(i),ISTUP(i),(MOTHUP(j,i),j=1,2),(ICOLUP(j,i),j=1,2),
     >     (PUP(j,i),j=1,5),VTIMUP(i),SPINUP(i),i=1,NUP)

      return
      end
      subroutine lhaWritHdAsc(lun)
      implicit none

C  Write the "header" (run information) records of the LHA external event 
C  interface into a file (LUN = "lun") in an ASCII format.
C  The data can be read back using "lhaReadHdAsc".
C  May 6, 2004, S. Odaka (KEK)
C
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      integer lun,i

C  Header data
      write(lun,100) IDBMUP,EBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP

C  Process data
      do i=1,NPRUP
         write(lun,101) XSECUP(i),XERRUP(i),XMAXUP(i),LPRUP(i)
      enddo

 100  format(2I6,2E15.7,6I6)
 101  format(3E15.7,I6)

      return
      end
      subroutine lhaWritHdBin(lun)
      implicit none

C  Write the "header" (run information) records of the LHA external event 
C  interface into a file (LUN = "lun") as unformatted binary records.
C  The data can be read back using "lhaReadHdBin".
C  May 6, 2004, S. Odaka (KEK)
C
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      integer lun,i

C  Header data
      write(lun) IDBMUP,EBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP

C  Process data
      do i=1,NPRUP
         write(lun) XSECUP(i),XERRUP(i),XMAXUP(i),LPRUP(i)
      enddo

      return
      end
