      SUBROUTINE UPINIT
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      INTEGER I,J
      CHARACTER*3 CBEAM
      DOUBLE PRECISION SIGMAX

C...PDF common parameter.
C      CHARACTER*20      PARM(20)
C      DOUBLE PRECISION  VALUE(20)

C...Initialization of GR@PPA parameters.
      CALL GRCINIT

C...Beams: 'PP' for proton-proton, and 'PAP' for proton-antiproton.
      CBEAM = 'PP'              ! LHC
C      CBEAM = 'PAP'             ! Tevatron

C...CM energy in GeV. 
      GRCECM = 14000.0D0         ! LHC
C      GRCECM =  1960.0D0         ! Tevatron

C...Number of external processes, and process numbers. 
      NPRUP = 2
      LPRUP(1) = 110            ! Z + 0 jet
      LPRUP(2) = 111            ! Z + 1 jet

C...ME-PS matching.
      matching= 1    ! Turn on the LLL subtraction
      ishower= 1     ! Turn on the Kurihara's QCDPS for the initial state

C...Jet flavor to produce.
      IGJFLV(1) = 1             ! d-jet
      IGJFLV(2) = 1             ! u-jet
      IGJFLV(3) = 1             ! s-jet
      IGJFLV(4) = 1             ! c-jet
      IGJFLV(5) = 1             ! b-jet
      IGJFLV(7) = 1             ! gluon-jet

C...Z Decay Mode. (1/0:on/off)
      IGZMOD(1)  = 0            ! z -> d d~
      IGZMOD(2)  = 0            ! z -> u u~
      IGZMOD(3)  = 0            ! z -> s s~
      IGZMOD(4)  = 0            ! z -> c c~
      IGZMOD(5)  = 0            ! z -> b b~
      IGZMOD(6)  = 0            ! z -> t t~
      IGZMOD(9)  = 1            ! z -> e e
      IGZMOD(10) = 0            ! z -> nu_e nu_e
      IGZMOD(11) = 0            ! z -> mu mu
      IGZMOD(12) = 0            ! z -> nu_mu nu_mu
      IGZMOD(13) = 0            ! z -> tau tau
      IGZMOD(14) = 0            ! z -> nu_tau nu_tau

C...Set seeds for random numbers.
      IRSEED = 12345

C...Set PDF.
      PDFGUP(1) = -1
      PDFSUP(1) = -1
      PDFGUP(2) = PDFGUP(1)
      PDFSUP(2) = PDFSUP(1)
C--------------------------------------------
C...If PDFLIB/CERNLIB is used, ...
C...Initialization of PDFLIB.
C      PARM(1) = 'Init0'
C      VALUE(1) = 0.0d0
C      CALL PDFSET(PARM, VALUE)
C
C...Set PDF's of incoming beams: CTEQ 5L.
C      PARM(1) = 'Nptype'
C      VALUE(1) = 1
C      PARM(2) = 'Ngroup'
C      VALUE(2) = 4
C      PARM(3) = 'Nset'
C      VALUE(3) = 46
C      CALL PDFSET(PARM, VALUE)
C
C      PDFGUP(1) = VALUE(2)
C      PDFSUP(1) = VALUE(3)
C      PDFGUP(2) = PDFGUP(1)
C      PDFSUP(2) = PDFSUP(1)
C--------------------------------------------
C...If LHAPDF is used, ...
C...Initialization of LHAPDF
C   The target PDF-set file has to be copied to this directory, or 
C   edit the next line properly.
C      CALL InitPDFset('cteq6.LHpdf')
C      CALL InitPDF(0)
C--------------------------------------------
C...If the build-in CTEQ6L1 is used, ...
      CALL SetCtq6(4)
C--------------------------------------------

C...Kinematical cuts for "jets".
      GPTCUT   = 1.0D0          ! Pt Cut
      GETACUT  = 10.0D0         ! Eta Cut
      GRCONCUT = 0.4D0          ! RCone Cut

C  Initialization of QCDPS.
      if( ishower.eq.1 ) then
         Ebeam= GRCECM/2.d0
         call QPINIT(Ebeam)
C  Force to set QCD Lambda in QCDPS.
C         vlambda= 0.1650d0
C         call QPsetLd( vlambda )
      endif

C...Set incoming beams in the interface common.
      IF (CBEAM.EQ.'PP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = 2212
      ELSEIF (CBEAM.EQ.'PAP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = -2212
      ELSE
         PRINT '('' Incorrect beam definition: CBEAM = '',A4)',
     >        CBEAM
         STOP
      ENDIF
      EBMUP(1) = GRCECM/2.0D0
      EBMUP(2) = GRCECM/2.0D0

C...Weighting strategy.
      IDWTUP = -3

C...Check the process.
      DO I = 1,NPRUP
         IF (LPRUP(I).LT.100.OR.LPRUP(I).GT.600) THEN
            WRITE(*,*) 'GRC::Error: Wrong process ID',LPRUP(I),'.'
            STOP
         ENDIF
      ENDDO

C...Integration step of GR@PPA.
      DO I = 1,NPRUP
         CALL GRCPYGEN(CBEAM,LPRUP(I),1,SIGMAX)
         XSECUP(i) = SIGMAX
         XMAXUP(i) = 1.0D0
      ENDDO

C...Done.
      RETURN
      END
