      PROGRAM pymain
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 lhafile

Ch      parameter ( lhcom = 100000 )
Ch      real*4 h
Ch      common /pawc/h(lhcom)
Ch      character*72 flhist
      real*4 weight

C  For di-boson process
      integer ipvec(2)
      dimension pVV(4)

C  Output hbook file; "*" for no output.
C      flhist= '*'
Ch      flhist= 'hist.hbook'

C...Number of events. 
      NEV = 9999999                 ! Number of events

C...Pythia initialization.
C   Switch off unnecessary aspects of Pythia.
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization

C  Reset the energy-scale factor
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
C      PARP(71)= ( 91.188/4.6 )**2    ! FSR energy scale factor.

C...Initialization.
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)

C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)

C  Primordial kT
      print *,'Primordial kT mode mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
Ch      call hlimit(lhcom)

Ch      call hbook1(1,'mass of V$',100,0.,200.,0.)
Ch      call hbook1(2,'pt of V$',100,0.,200.,0.)
Ch      call hbook1(3,'rapidity of V$',100,-5.,5.,0.)

Ch      call hbook1(11,'mass of VV$',100,0.,1000.,0.)
Ch      call hbook1(12,'pt of VV$',100,0.,200.,0.)
Ch      call hbook1(13,'rapidity of VV$',100,-5.,5.,0.)
Ch      call hbook1(14,'pt of VV (fine)$',100,0.,20.,0.)

Ch      call hbook1(30,'Num. of PS jets (all)$',50,0.,50.,0.)
Ch      call hbook1(31,'Num. of PS jets (pos)$',50,0.,50.,0.)
Ch      call hbook1(32,'Num. of PS jets (neg)$',50,0.,50.,0.)

Ch      call hbook1(42,'pt of VV (non-rad)$',100,0.,200.,0.)
Ch      call hbook1(52,'pt of VV (rad)$',100,0.,200.,0.)

Ch      call hbook1(100,'Num. of Vs$',10,0.,10.,0.)

Ch      call hbook1(101,'mass of V$',100,0.,200.,0.)
Ch      call hbook1(102,'pt of V$',100,0.,200.,0.)
Ch      call hbook1(103,'rapidity of V$',100,-5.,5.,0.)

Ch      call hbook1(111,'mass of VV$',100,0.,1000.,0.)
Ch      call hbook1(112,'pt of VV$',100,0.,200.,0.)
Ch      call hbook1(113,'rapidity of VV$',100,-5.,5.,0.)
Ch      call hbook1(114,'pt of VV (fine)$',100,0.,20.,0.)

Ch      call hbook1(121,'mass of VV (pos)$',100,0.,1000.,0.)
Ch      call hbook1(122,'pt of VV (pos)$',100,0.,200.,0.)
Ch      call hbook1(123,'rapidity of VV (pos)$',100,-5.,5.,0.)

Ch      call hbook1(131,'mass of VV (neg)$',100,0.,1000.,0.)
Ch      call hbook1(132,'pt of VV (neg)$',100,0.,200.,0.)
Ch      call hbook1(133,'rapidity of VV (neg)$',100,-5.,5.,0.)

Ch      call hbook1(142,'pt of VV (non-rad)$',100,0.,200.,0.)
Ch      call hbook1(152,'pt of VV (rad)$',100,0.,200.,0.)

Ch      call hbook1(144,'pt of VV (non-rad)$',100,0.,20.,0.)
Ch      call hbook1(154,'pt of VV (rad)$',100,0.,20.,0.)

C  Integrated absolute cross section.
      xabs= 0.d0
      do i=1,NPRUP
         xabs= xabs +XSECUP(i)
      enddo

      evpos= 0.d0
      evneg= 0.d0

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         if( IEV.le.2 .or. mod(IEV,100).eq.0 ) then
            CALL PYLIST(1)
         endif

C  Analysis
C (input data)
         nvec= 0
         npsjet= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.23 .or. idabs.eq.24 ) then
               nvec= nvec +1
               if( nvec.le.2 ) ipvec(nvec)= i
            endif
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) npsjet= npsjet +1
         enddo

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

         do i=1,2
            ip= ipvec(i)
            amV= PUP(5,ip)
            ptV= sqrt( PUP(1,ip)**2 +PUP(2,ip)**2 )
            rapV= log( ( PUP(4,ip) +PUP(3,ip) )
     >           /( PUP(4,ip) -PUP(3,ip) ) )/2.d0
Ch            call hf1(1,real(amV),1.)
Ch            call hf1(2,real(ptV),1.)
Ch            call hf1(3,real(rapV),1.)
         enddo

         do i=1,4
            pVV(i)= PUP(i,ipvec(1)) +PUP(i,ipvec(2))
         enddo
         amVV= sqrt( pVV(4)**2 -pVV(3)**2 -pVV(2)**2 -pVV(1)**2 )
         ptVV= sqrt( pVV(1)**2 +pVV(2)**2 )
         rapVV= log( ( pVV(4) +pVV(3) )/( pVV(4) -pVV(3) ) )/2.d0
Ch         call hf1(11,real(amVV),weight)
Ch         call hf1(12,real(ptVV),weight)
Ch         call hf1(13,real(rapVV),weight)
Ch         call hf1(14,real(ptVV),weight)

Ch         call hf1(30,npsjet+.5,1.)
Ch         if( weight.ge.0. ) then
Ch            call hf1(31,npsjet+.5,1.)
Ch         else
Ch            call hf1(32,npsjet+.5,1.)
Ch         endif

Ch         if( IDPRUP.eq.120 .or. IDPRUP.eq.130 .or. IDPRUP.eq.140 ) then
Ch            call hf1(42,real(ptVV),weight)
Ch         elseif( IDPRUP.eq.121 .or. IDPRUP.eq.131 
Ch     >        .or. IDPRUP.eq.141 ) then
Ch            call hf1(52,real(ptVV),weight)
Ch         endif

C  (after PYTHIA)
         nvec= 0
         do i=1,N
            if( K(i,1).eq.11 ) then
               idabs= iabs( K(i,2) )
               if( idabs.eq.23 .or. idabs.eq.24 ) then
                  nvec= nvec +1
                  if( nvec.le.2 ) ipvec(nvec)= i
               endif
            endif
         enddo
Ch         call hf1(100,nvec+.5,1.)

         do i=1,2
            ip= ipvec(i)
            amV= P(ip,5)
            ptV= sqrt( P(ip,1)**2 +P(ip,2)**2 )
            rapV= log( ( P(ip,4) +P(ip,3) )
     >           /( P(ip,4) -P(ip,3) ) )/2.d0
Ch            call hf1(101,real(amV),weight)
Ch            call hf1(102,real(ptV),weight)
Ch            call hf1(103,real(rapV),weight)
         enddo

         do i=1,4
            pVV(i)= P(ipvec(1),i) +P(ipvec(2),i)
         enddo
         amVV= sqrt( pVV(4)**2 -pVV(3)**2 -pVV(2)**2 -pVV(1)**2 )
         ptVV= sqrt( pVV(1)**2 +pVV(2)**2 )
         rapVV= log( ( pVV(4) +pVV(3) )/( pVV(4) -pVV(3) ) )/2.d0
Ch         call hf1(111,real(amVV),weight)
Ch         call hf1(112,real(ptVV),weight)
Ch         call hf1(113,real(rapVV),weight)
Ch         call hf1(114,real(ptVV),weight)
Ch         if( weight.gt.0.d0 ) then
Ch            call hf1(121,real(amVV),1.)
Ch            call hf1(122,real(ptVV),1.)
Ch            call hf1(123,real(rapVV),1.)
Ch         else
Ch            call hf1(131,real(amVV),1.)
Ch            call hf1(132,real(ptVV),1.)
Ch            call hf1(133,real(rapVV),1.)
Ch         endif

Ch         if( IDPRUP.eq.120 .or. IDPRUP.eq.130 .or. IDPRUP.eq.140 ) then
Ch            call hf1(142,real(ptVV),weight)
Ch            call hf1(144,real(ptVV),weight)
Ch         elseif( IDPRUP.eq.121 .or. IDPRUP.eq.131 
Ch     >           .or. IDPRUP.eq.141 ) then
Ch            call hf1(152,real(ptVV),weight)
Ch            call hf1(154,real(ptVV),weight)
Ch         endif

C...End of loop over events.
      ENDDO

 9000 continue

C...Cross section table.
      CALL PYSTAT(1)

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6)', rneg
      xsec= xabs*evdif/evtot
      xerr= xabs/sqrt( evtot )
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'-----------------------------'

C...Histograms.
Ch      call histdo
C
C -- Store histograms.
C
Ch      if( flhist(1:1).NE.'*' ) then
Ch        call hrput(0,flhist,'N')
Ch      endif

      stop
      END
