C--------------------------------------
C Provide to each subprocess function.
C--------------------------------------
      function func(x)
      implicit real*8(a-h,o-z)

#include "define2.h"

      common /amjprc/jproc
      include 'grchad.inc'
      parameter ( mxdim = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      real*8  x(mxdim)
      real*8  xsn(10),rna
      integer imrg,ijrg

      if (igsub.lt.200.and.ibsint.lt.2) then
C...Set Parameter for kinematics
         call grcikin
C...Integration/Event Generation : 1/0
         do i = 1, ndim
            xrun(i) = x(i)
         enddo
      endif

C Add a new process here. (FUNC)

C  Cut on the finally generated event.
      call funcLabCut( ireject )
      if( ireject.gt.0 ) func= 0.d0

      if (ibsint.lt.2) then
         if (jproc.gt.99.and.jproc.lt.200) then
            igsub = jproc
         endif
      endif

      return
      end

      subroutine funcLabCut( ireject )
      implicit real*8(a-h,o-z)
      include 'grchad.inc'
      common/QPlock/xpdf_lock(2),iqplock

      ireject= 0

      if( yacob.le.0.d0 ) goto 999
      if( labcut.eq.1 ) then
         CALL GRCSSMR
         call lhaPartFix
         if( ishower.eq.1 .and. iqplock.eq.0 ) then
            ldebug= 0
            call pskini( ldebug, ifail )
            if( ifail.ne.0 ) goto 999
         endif
         call ps2lha
         call grclabcut( icut )
         if( icut.gt.0 ) goto 999
      endif

      return

 999  continue
      yacob = 0.d0
      ireject= 1
      return
      end

C-------------------------------
C Kinematics of original GRACE.
C-------------------------------
      subroutine labtok(p1,p2,p3,p4, p5,p6)
*
      implicit real*8(a-h,o-z)
      real*8 p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)
      real*8 pl2k(4),pt1(4),rl2k(3,3)
*
      do 1 i=1,4
         pl2k(i)=-p2(i)
 1    continue
      pl2k(4)= p2(4)
*
      call pboost(p1,pl2k, pt1)
      call rotmtx(pt1, rl2k)
*
      call pboost(p3,pl2k, p5)
      call mvmult(rl2k,p5, p5)
      call pboost(p4,pl2k, p6)
      call mvmult(rl2k,p6, p6)
*
      return
      end

      SUBROUTINE MEMCLR(R,N1,N2)
      REAL*8 R(9)
      DO 1 I=1,N1
 1       R(I)=N2
      RETURN
      END

      SUBROUTINE MMMULT(R1,R2,R3)
      REAL*8 R1(3,3),R2(3,3),R3(3,3),RDUMMY(3,3)
      CALL MEMCLR(RDUMMY,9,0)
      DO 1 I=1,3
         DO 2 J=1,3
            DO 3 K=1,3
 3             RDUMMY(I,J)=RDUMMY(I,J)+R1(I,K)*R2(K,J)
 2       CONTINUE
 1    CONTINUE
      DO 4 I=1,3
         DO 5 J=1,3
 5          R3(I,J)=RDUMMY(I,J)
 4    CONTINUE
C
      RETURN
      END

      SUBROUTINE MVMULT(R,P1,P2)
      REAL*8 R(3,3),P1(4),P2(4),PTMP(4)
C
      PTMP(1)=P1(1)*R(1,1)+P1(2)*R(1,2)+P1(3)*R(1,3)
      PTMP(2)=P1(1)*R(2,1)+P1(2)*R(2,2)+P1(3)*R(2,3)
      PTMP(3)=P1(1)*R(3,1)+P1(2)*R(3,2)+P1(3)*R(3,3)
      PTMP(4)=P1(4)
C
      P2(1)=PTMP(1)
      P2(2)=PTMP(2)
      P2(3)=PTMP(3)
      P2(4)=PTMP(4)
C
      RETURN
      END

      SUBROUTINE PBOOST(P,Q,PB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(4),Q(4),PB(4)
C
      PQ=P(1)*Q(1)+P(2)*Q(2)+P(3)*Q(3)
      Q2=Q(1)**2+Q(2)**2+Q(3)**2
      Q1=SQRT(Q2)
C
      AM=SQRT( (Q(4)-Q1)*(Q(4)+Q1) )
      F=((Q(4)-AM)*PQ/Q2+P(4))/AM
      PB(1)= P(1)+Q(1)*F
      PB(2)= P(2)+Q(2)*F
      PB(3)= P(3)+Q(3)*F
      PB(4)=(P(4)*Q(4)+PQ)/AM
      RETURN
      END

      SUBROUTINE ROTMTX(PAX, ROT)
* Debug 27/DEC/94 Y.Kurihara: To treat PAX(1)**2+PAX(2)**2=0
* Debug 04/Jan/95 Y.Kurihara: den>1.d-15 -->den>1.d-10 
*       19/Jan/95 Y.Kurihara: To treat phi rotation    
*
      IMPLICIT REAL* 8(A-H,O-Z)
      REAL*8 PAX(4)
      REAL*8 ROT(3,3),ROTTMP(3,3)
      den=SQRT(PAX(1)*PAX(1)+PAX(2)*PAX(2))
      if(den.le.1.d-10) then
         CALL MEMCLR(ROT,9,0)
         rot(1,1)=sign(1.d0,pax(3))
         rot(2,2)=sign(1.d0,pax(3))
         rot(3,3)=sign(1.d0,pax(3))
         return
      end if
      COSA=PAX(1)/den
      SINA=PAX(2)/den
      CALL MEMCLR(ROTTMP,9,0)
      ROTTMP(1,1)= COSA
      ROTTMP(1,2)= SINA
      ROTTMP(2,1)=-SINA
      ROTTMP(2,2)= COSA
      ROTTMP(3,3)= 1
      CALL MVMULT(ROTTMP,PAX,PAX)
      CALL MEMCLR(ROT,9,0)
      COSB=PAX(3)/SQRT(PAX(1)*PAX(1)+PAX(3)*PAX(3))
      SINB=PAX(1)/SQRT(PAX(1)*PAX(1)+PAX(3)*PAX(3))
      ROT(1,1)= COSB
      ROT(1,3)=-SINB
      ROT(2,2)= sign(1.d0,pax(3))
      ROT(3,1)= SINB
      ROT(3,3)= COSB
      CALL MMMULT(ROT,ROTTMP,ROT)
      RETURN
      END

C---------------------------------
C Set Coupling for each particle.
C---------------------------------
      subroutine amparm
      implicit real*8(a-h,o-z)
*
      include 'inclm.h'
      include 'inclc.h'

* User Define
      include 'grchad.inc'

      complex*16 zr, zi
      save       zr, zi
      zr = dcmplx(1.0d0, 0.0d0)
      zi = dcmplx(0.0d0, 1.0d0)
*-----------------------------------------------------------------------
*     call sminit(   1,   1)
*-----------------------------------------------------------------------
* coupling constants
*
      zero      =   0.0d0
      one       =   1.0d0
      two       =   2.0d0
      three     =   3.0d0
      four      =   4.0d0
*
*  QED coupling constant
*
      r2        =   sqrt(two)
      r2i       =   one/r2

C==================================================
      if (igauge.eq.1) then
C...gauge invariant sets : (gf, mw, mz)
         sth2 = 1.0d0 - amw**2/amz**2
         alpha = sth2*r2*gf*amw**2/pi
         ge2 = four*pi*alpha
      else if (igauge.eq.2) then
C...gauge invariant sets : (alpha, mw, mz)
         ge2 = four*pi*alpha
      else if (igauge.eq.3) then
C...gauge invariant sets : (alpha0, gf, mw)
         ge2 = four*pi*alpha0
      else if (igauge.eq.4) then
C...gauge invariant sets : (sin2W, gf, mw)
         alpha = sth2*r2*gf*amw**2/pi
         ge2 = four*pi*alpha
      endif
C==================================================
      ge        =   sqrt(ge2)
      ge2h      =   ge2/two
      cqed      =   ge
*
*  Electric charges
*
      ql        = - one

C  Change the parameter for various grcflav

      qu        =   two/three
      qd        = - one/three

*
*  Electro-weak coupling constants
*
*   Gauge coupling constants
*
      amw2      =   amw**2
      amh2      =   amh**2

C==================================================
      if (igauge.eq.1) then
C...gauge invariant sets : (gf, mw, mz)
         gcos = amw/amz
      else if (igauge.eq.2) then
C...gauge invariant sets : (alpha, mw, mz)
         gcos = amw/amz
      else if (igauge.eq.3) then
C...gauge invariant sets : (alpha0, gf, mw)
         sth2 = pi*alpha0/r2/gf/amw2
         cth2 = 1.0d0 - sth2
         bmw2 = amw2
         bmz2 = bmw2/cth2
         bmw  = sqrt(bmw2)
         bmz  = sqrt(bmz2)
         gcos = bmw/bmz
      else if (igauge.eq.4) then
C...gauge invariant sets : (sin2W, gf, mw)
         cth2 = 1.0d0 - sth2
         bmw2 = amw2
         bmz2 = bmw2/cth2
         bmw  = sqrt(bmw2)
         bmz  = sqrt(bmz2)
         gcos = bmw/bmz
      endif
C==================================================

      gcos2     =   gcos**2
      gsin      =   sqrt(one-gcos2)
      gtan      =   gsin/gcos
      gcosi     =   one/gcos
      gcos2i    =   one/gcos2
      gcosd     =   two*gcos2 - one
*
      gg        =   ge/gsin
      gg2       =   gg**2
      ggh       =   gg/two
      gg2h      =   gg2/two
*
*   SSS and SSSS
      gs        =   gg *amh2/(two *amw )
      gs2       =   gg2*amh2/(four*amw2)
*
*   FFW
      gwfl      =   gg*r2i
*
*   FFA
      gal       =   ql*ge
*
      gau       =   qu*ge
      gad       =   qd*ge
*
*   FFZ
      gza       =   ggh*gcosi
      gzc       =   gg*gtan*gsin
*
      gznl      =   gza
*
      gzll      = - ql*gzc - gza
      gzlr      = - ql*gzc
*

C  Change the parameter for various grcflav for Z coupling

      gzul      = - qu*gzc + gza
      gzur      = - qu*gzc
*
      gzdl      = - qd*gzc - gza
      gzdr      = - qd*gzc
*
*   SFF
      gx        =   gg*r2i/amw
*
      g3        =   ggh/amw
*
*
*
* QCD coupling constants
*
      cqcd      =   sqrt(four*pi*alphas) 
*
*
*=======================================
* VVV
*---------------------------------------
      czww    = zr*( gg*gcos)
      caww    = zr*( ge)
      cggg    = zr*( cqcd)
*
*---------------------------------------
* VVVV
*---------------------------------------
      cwwaa    = zr*( ge2)
      cwwza    = zr*( ge*gg*gcos)
      cwwzz    = zr*( gg2*gcos2)
      cwwww    = zr*(-gg2)
      cgggg    = zr*( cqcd**2)
*
*---------------------------------------
* SSV
*---------------------------------------
      cwhm    = zi*( ggh)
      cwhp    = zi*( ggh)
      cwym    = zr*( ggh)
      cwyp    = zr*(-ggh)
      czpm    = zr*(-ggh*gcosd*gcosi)
      capm    = zr*(-ge)
      czhy    = zi*( ggh*gcosi)
*
*---------------------------------------
* SVV
*---------------------------------------
      chww    = zr*( gg*amw)
      chzz    = zr*( gg*amz*gcosi)
      cwzm    = zi*( ge*amz*gsin)
      cwam    = zi*(-ge*amw)
      cwzp    = zi*(-ge*amz*gsin)
      cwap    = zi*( ge*amw)
*
*---------------------------------------
* SSVV
*---------------------------------------
      cwwhh    = zr*( gg2h)
      czzhh    = zr*( gg2h*gcos2i)
      cwzhm    = zi*( ge2h*gcosi)
      cwzhp    = zi*(-ge2h*gcosi)
      cwahm    = zi*(-ge*ggh)
      cwahp    = zi*( ge*ggh)
      cwwyy    = zr*( gg2h)
      czzyy    = zr*( gg2h*gcos2i)
      cwzym    = zr*( ge2h*gcosi)
      cwzyp    = zr*( ge2h*gcosi)
      cwaym    = zr*(-ge*ggh)
      cwayp    = zr*(-ge*ggh)
      cwwpm    = zr*( gg2h)
      czzpm    = zr*( gg2h*(gcosd*gcosi)**2)
      caapm    = zr*( two*ge2)
      czapm    = zr*( ge*gg*gcosd*gcosi)
*
*---------------------------------------
* SSS
*---------------------------------------
      chpm    = zr*(-gs)
      chyy    = zr*(-gs)
*
      chhh    = zr*(-three*gs)
*
*---------------------------------------
* SSSS
*---------------------------------------
      chhhh    = zr*(-three*gs2)
      cyyyy    = zr*(-three*gs2)
      cpmyy    = zr*(-gs2)
      chhpm    = zr*(- gs2)
      chhyy    = zr*(-gs2)
      cpmpm    = zr*(-two*gs2)
*
      do 100 i = 1, 3
*---------------------------------------
* FFV (FFW : without quark mixing)
*---------------------------------------
         cwln(1,i) = zr*( gwfl)
         cwln(2,i) = zr*0
         cwnl(1,i) = zr*( gwfl)
         cwnl(2,i) = zr*0
         cwdu(1,i) = zr*( gwfl)
         cwdu(2,i) = zr*0
         cwud(1,i) = zr*( gwfl)
         cwud(2,i) = zr*0
*
*---------------------------------------
* FFV (FFA)
*---------------------------------------
         call(1,i) = zr*( gal)
         call(2,i) = zr*( gal)
         cauu(1,i) = zr*( gau)
         cauu(2,i) = zr*( gau)
         cadd(1,i) = zr*( gad)
         cadd(2,i) = zr*( gad)

*
*---------------------------------------
* FFV (FFZ)
*---------------------------------------
         cznn(1,i) = zr*( gznl)
         cznn(2,i) = zr*0
         czll(1,i) = zr*( gzll)
         czll(2,i) = zr*( gzlr)
*
         czuu(1,i) = zr*( gzul)
         czuu(2,i) = zr*( gzur)
         czdd(1,i) = zr*( gzdl)
         czdd(2,i) = zr*( gzdr)

*
*---------------------------------------
* FFV (FFg)
*---------------------------------------
*
         cguu(1,i) = zr*( cqcd)
         cguu(2,i) = zr*( cqcd)
         cgdd(1,i) = zr*( cqcd)
         cgdd(2,i) = zr*( cqcd)
*
*
*---------------------------------------
* XFF
*---------------------------------------
         cmln(1,i) = zi*( amlp(i)*gx)
         cmln(2,i) = zi*0
*
         cpnl(1,i) = zi*0
         cpnl(2,i) = zi*(-amlp(i)*gx)
*
         cmdu(1,i) = zi*( amdq(i)*gx)
         cmdu(2,i) = zi*(-amuq(i)*gx)
         cpud(1,i) = zi*( amuq(i)*gx)
         cpud(2,i) = zi*(-amdq(i)*gx)
*
*---------------------------------------
* HFF
*---------------------------------------
         chll(1,i) = zr*(-amlp(i)*g3)
         chll(2,i) = zr*(-amlp(i)*g3)
         chuu(1,i) = zr*(-amuq(i)*g3)
         chuu(2,i) = zr*(-amuq(i)*g3)
         chdd(1,i) = zr*(-amdq(i)*g3)
         chdd(2,i) = zr*(-amdq(i)*g3)
*
*
*---------------------------------------
* FFX3
*---------------------------------------
         cyll(1,i) = zi*(-amlp(i)*g3)
         cyll(2,i) = zi*( amlp(i)*g3)
         cyuu(1,i) = zi*( amuq(i)*g3)
         cyuu(2,i) = zi*(-amuq(i)*g3)
         cydd(1,i) = zi*(-amdq(i)*g3)
         cydd(2,i) = zi*( amdq(i)*g3)
 100  continue
*
*---------------------------------------
* CCV
*---------------------------------------
      cwczp    = zr*(-gg*gcos)
      cwcmz    = zr*( gg*gcos)
      cwcap    = zr*(-ge)
      cwcma    = zr*( ge)
      cwczm    = zr*( gg*gcos)
      cwcpz    = zr*(-gg*gcos)
      cwcam    = zr*( ge)
      cwcpa    = zr*(-ge)
      czcmm    = zr*(-gg*gcos)
      czcpp    = zr*( gg*gcos)
      cacmm    = zr*(-ge)
      cacpp    = zr*( ge)
*
      cgcgg    = zr*( cqcd)
*
*---------------------------------------
* SCC
*---------------------------------------
      cpczp    = zi*(-ggh*gcosd*amz)
      cpcap    = zi*(-ge*amw)
      cpcmz    = zi*( ggh*amz)
      cmczm    = zi*( ggh*gcosd*amz)
      cmcam    = zi*( ge*amw)
      cmcpz    = zi*(-ggh*amz)
      cycmm    = zi*(-ggh*amw)
      cycpp    = zi*( ggh*amw)
*
      chcmm    = zr*(-ggh*amw)
      chcpp    = zr*(-ggh*amw)
      chczz    = zr*(-ggh*gcosi*amz)

C  Modifications for Z/gamma* + jets production processes.
C  This part may be better to move to ME calculation packages.
      if( igsub.ge.500 .and. igsub.le.525 ) then
         if (grcflav.eq.0) then
C  gg
         else if (grcflav.lt.13) then
C  qq~
            if (grcflav.eq.2.or.grcflav.eq.4
     $           .or.grcflav.eq.6.or.grcflav.eq.8
     $           .or.grcflav.eq.9.or.grcflav.eq.10) then
               cauu(1,1) = cadd(1,1)
               cauu(2,1) = cadd(2,1)
               czuu(1,1) = czdd(1,1)
               czuu(2,1) = czdd(2,1)
            endif
         else if (grcflav.lt.37) then
C  qq'~
         else if (grcflav.lt.61) then
C  qg
            if (grcflav.lt.53) then
               if (mod(grcflav,2).eq.0) then
                  cauu(1,1) = cadd(1,1)
                  cauu(2,1) = cadd(2,1)
                  czuu(1,1) = czdd(1,1)
                  czuu(2,1) = czdd(2,1)
               endif
            else if (grcflav.lt.57) then
               cauu(1,1) = cadd(1,1)
               cauu(2,1) = cadd(2,1)
               czuu(1,1) = czdd(1,1)
               czuu(2,1) = czdd(2,1)
            endif
         endif
      endif

      return
      end


*     File ammas2.f : Fri Jan 19 11:16:41 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine ammas2
      implicit real*8(a-h,o-z)

      include 'inclm.h'
*-----------------------------------------------------------------------
* mass**2
*-----------------------------------------------------------------------
      amw2 =    amw**2
      amz2 =    amz**2
      ama2 =    ama**2
      amg2 =    amg**2
      amg2 =    amg**2
      amg2 =    amg**2
      amh2 =    amh**2
      amx2 =    amx**2
      amy2 =    amy**2
      amnu2(1) = amnu(1)**2
      amnu2(2) = amnu(2)**2
      amnu2(3) = amnu(3)**2
      amlp2(1) = amlp(1)**2
      amlp2(2) = amlp(2)**2
      amlp2(3) = amlp(3)**2
      amuq2(1) = amuq(1)**2
      amuq2(2) = amuq(2)**2
      amuq2(3) = amuq(3)**2
      amdq2(1) = amdq(1)**2
      amdq2(2) = amdq(2)**2
      amdq2(3) = amdq(3)**2
      amcp2 =   amcp**2
      amcm2 =   amcm**2
      amcz2 =   amcz**2
      amca2 =   amca**2
      amcg2 =   amcg**2

      return
      end


*     File amkfcd.f : Fri Jan 19 11:16:41 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine amkfcd
      implicit real*8(a-h,o-z)

      include 'inclm.h'
      include 'inclc.h'
*-----------------------------------------------------------------------
      do 10 i = 1, 25
         amprtl(i) = -1.0d30
         agprtl(i) = -1.0d30
 10   continue

* mass as a function of KF-code
*
      amprtl(24) =    amw
      agprtl(24) =    agw
      amprtl(23) =    amz
      agprtl(23) =    agz
      amprtl(22) =    ama
      agprtl(22) =      0
      amprtl(21) =    amg
      agprtl(21) =      0

*** no KF-code for g4aux
*     amprtl(??) =    amg
*     agprtl(??) =      0


*** no KF-code for g41aux
*     amprtl(??) =    amg
*     agprtl(??) =      0

      amprtl(25) =    amh
      agprtl(25) =    agh

*** no KF-code for chi-plus
*     amprtl(??) =    amx
*     agprtl(??) =    agx

      amprtl(18) =    amy
      agprtl(18) =    agy
      amprtl(12) = amnu(1)
      agprtl(12) =      0
      amprtl(14) = amnu(2)
      agprtl(14) =      0
      amprtl(16) = amnu(3)
      agprtl(16) =      0
      amprtl(11) = amlp(1)
      agprtl(11) =      0
      amprtl(13) = amlp(2)
      agprtl(13) =      0
      amprtl(15) = amlp(3)
      agprtl(15) =      0
      amprtl( 2) = amuq(1)
      agprtl( 2) = aguq(1)
      amprtl( 4) = amuq(2)
      agprtl( 4) = aguq(2)
      amprtl( 6) = amuq(3)
      agprtl( 6) = aguq(3)
      amprtl( 1) = amdq(1)
      agprtl( 1) = agdq(1)
      amprtl( 3) = amdq(2)
      agprtl( 3) = agdq(2)
      amprtl( 5) = amdq(3)
      agprtl( 5) = agdq(3)

*** no KF-code for c-plus
*     amprtl(??) =   amcp
*     agprtl(??) =   agcp


*** no KF-code for c-minus
*     amprtl(??) =   amcm
*     agprtl(??) =   agcm


*** no KF-code for c-z
*     amprtl(??) =   amcz
*     agprtl(??) =   agcz


*** no KF-code for c-a
*     amprtl(??) =   amca
*     agprtl(??) =      0


*** no KF-code for c-g
*     amprtl(??) =   amcg
*     agprtl(??) =      0

      return
      end

*     File snprpd.f : Mon Apr  9 01:18:32 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine snprpd(pphase, aprop, amomq, amassq, amag)
      implicit real*8(a-h,o-z)
      complex*16 pphase, aprop
      real*8     amomq, amassq, amag
      common /chcntl/ jwidth, jtgamm
*
*    calculate denominator of propagator.
*
*     pphase : input  : phase of the propagator
*     aprop  : in/out : product of denominator of propagators.
*     amomp  : input  : square of mementum.
*     amassq : input  : square of mass.
*     amag   : input  : mass * width.
*-----------------------------------------------------------------------
      if (amomq .gt. 0) then
         if(jwidth .eq. 0) then
            if(amassq .eq. 0.0d0) then
               wid=0.d0
            else
               wid=amag/amassq*amomq
            end if
            aprop = pphase*aprop*dcmplx(amomq - amassq, wid)
         else
            aprop = pphase*aprop*dcmplx(amomq - amassq, amag)
         endif
      else
         aprop = pphase*aprop*dcmplx(amomq - amassq, 0.0d0)
      endif
 
*     call ctime('smprpd')

      return
      end

*     File spdetc(isel).f : Mon Apr  9 01:18:28 2001
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.7(2) 1999/06/19
*
*     (c)copyright 1990-1999 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
************************************************************************
      subroutine spdetc(isel)
      implicit real*8(a-h,o-z)

#include "define2.h"

      include 'grchad.inc'
      common /amjprc/jproc
      integer isel

C Add a new process here. (SPDETC)

      return
      end

      subroutine spdeth(isel)
      implicit real*8(a-h,o-z)

#include "define2.h"

      include 'grchad.inc'
      common /amjprc/jproc
      integer isel

C Add a new process here. (SPDETH)

      return
      end


C-----------------------------------------
C Set general parameters of each process.
C-----------------------------------------
C refference : GRACE User's manual
C              http://www-sc.kek.jp/minami/
C
C isub    : ID Number from PYTHIA
C jproc   : ID Number of Each Subprocess for GRACE
C
C ibswrt  : Write to output file ( = 0 )
C         : Already exist        ( = 1 )
C
C icoup      : Set Energy Scale (Coupling Q^2).
C              if icoup = 1  ==> Q^2 = s^ for parton scale.
C                       = 2  ==> Q^2 = average value of transverse mass^2.
C                       = 3  ==> Q^2 = total transverse mass^2.
C                       = 4  ==> Q^2 = maximum transverse mass^2.
C                       = 5  ==> Q^2 = constant value.
C                               (Set grcq in GeV order)
C                       = 6  ==> user defined Q^2
C
C grcfile : Output File Name of BASES
C grcproc : Define New Process for PYTHIA(pyupin)
C
C ndim    : Dimension of Integral
C ncall   : Number of Sampling Points per Iteration
C
C ndim =    2    +        (3n - 4)              +      (1 or 0)
C        (x1,x2)   (# of kinematical variables)    (degree of flavor)
C Example
C  +-------------+-------+-------+-------+-------+-------+-------+
C  |  Number of  |       |       |       |       |       |       |
C  | final state |   2   |   2   |   3   |   3   |   4   |   4   |
C  +=============+=======+=======+=======+=======+=======+=======+
C  |   Initial   |    _  |       |    _  |       |    _  |       |
C  |    State    |  q q' | gl gl |  q q' | gl gl |  q q' | gl gl |
C  +-------------+-------+-------+-------+-------+-------+-------+
C  |     ndim    |   5   |   4   |   8   |   7   |  11   |  10   |
C  +-------------+-------+-------+-------+-------+-------+-------+
      subroutine grcpypro(isub,grcfile)
      implicit real*8(a-h,o-z)

#include "define2.h"

      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL

      include 'grchad.inc'
      common /amjprc/jproc

      character grcproc*40
      common/grcchar/grcproc

      integer isub
      character grcfile*60

      jproc = isub

C Add a new process here. (PROC)

      call grcpar(isub,grcfile)

      return
      end


C--------------------------------------------
C Set kinematics parameters of each process.
C--------------------------------------------
C
C  Ktype = 1  : 2-2 process
C        = 2  : 3-body final state, Q^2 is NOT a resonance(glu/gam splitting). 
C        = 3  : 3-body final state, Q^2 is a resonance production(W+-, Z, top).
C        = 4  : 3-body final state, Fusion type (ex. 1->4+A, 2->5+B, A+B->3)
C        = 5  : 4-body final state, Q^2(ij) : reso., Q^2(kl) : non-reso..
C        = 6  : 4-body final state, Q^2(ij) : non-reso., Q^2(kl) : non-reso..
C        = 7  : 4-body final state, Q^2(ij) : reso., Q^2(kl) : reso..
C        = 8  : 4-body final state, Cascade Decay, (345) + 6 -> 3 + (45) + 6
C        = 9  : 4-body final state, Fusion type (ex. 1->5+A, 2->6+B, A+B->3+4)
C
C CXtype = 1  : 2-body final state  3 + 4        => Default
C        = 2  : 3-body final state, 3 + (45)     => Default
C        = 3  :                     4 + (35)
C        = 4  :                     5 + (34)
C        = 5  : 4-body final state, (34) + (56)  => Default
C        = 6  :                     (35) + (46)
C        = 7  :                     (36) + (45)
C        = 8  :                     (45) + (36)
C        = 9  :                     (46) + (35)
C        = 10 :                     (56) + (34)
C        = 11 :                     (345) + 6 -> 3 + (45) + 6
C        = 12 :                     (345) + 6 -> 4 + (35) + 6
C        = 13 :                     (345) + 6 -> 5 + (34) + 6
C        = 14 :                     (346) + 5 -> 3 + (46) + 5
C        = 15 :                     (346) + 5 -> 4 + (36) + 5
C        = 16 :                     (346) + 5 -> 6 + (34) + 5
C        = 17 :                     (356) + 4 -> 3 + (56) + 4
C        = 18 :                     (356) + 4 -> 5 + (36) + 4
C        = 19 :                     (356) + 4 -> 6 + (35) + 4
C        = 20 :                     (456) + 3 -> 4 + (56) + 3
C        = 21 :                     (456) + 3 -> 5 + (46) + 3
C        = 22 :                     (456) + 3 -> 6 + (45) + 3
C
      subroutine grcikin
      implicit real*8(a-h,o-z)

#include "define2.h"

      include 'inclk.h'
      include 'grchad.inc'

      common /amjprc/jproc

C...Initialize of kinematical variables
      call grcival

C Add a new process here. (KINEM)

C...Set particle combination
      call grcspid

      return
      end


C-------------------
C Swap particle ID.
C-------------------
      subroutine grcswap(iset)
      implicit real*8(a-h,o-z)

      include 'grchad.inc'
      INCLUDE 'inclk.h'

      common /amjprc/jproc
      integer iset

      if (igsub.eq.550) then
C         if (iset.eq.2) then
C            call grcexkn(4,6)
C         endif
      endif

      return
      end

C--------------------
C Set cross section.
C--------------------
      subroutine grcxset(isel)
      implicit real*8(a-h,o-z)

#include "define2.h"

      common /amjprc/jproc
      include 'grchad.inc'
      include 'inclk.h'
      integer isel
      external drn

      isel = 1

C Add a new process here. (XSET)

      return
      end
