C        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C      _/_/ GR@PPA (GRace system @ PP/Anti-p)            _/_/
C     _/_/  File Name  : grchad.inc (Include File)      _/_/
C    _/_/   Date       : May.25.2004                  _/_/ 
C   _/_/    Author     : Soushi Tsuno (tsuno@fnal.gov)_/_/ 
C  _/_/     Institute  : Okayama Univ. Japan         _/_/
C _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C###########################
C###  Initial Parameter  ###
C###########################
      INTEGER IBSINT,IBSWRT,IREJ,IRSEED,NZZ,NFPRT
      COMMON/GRCINIT1/IBSINT,IBSWRT,IREJ,IRSEED,NZZ,NFPRT

      DOUBLE PRECISION GRCECM,FUNCMAX,GRCSIG
      COMMON/GRCINIT2/GRCECM,FUNCMAX,GRCSIG(1000)

      INTEGER IGSUB,IGPP,INPFL,ICOUP,IFACT,ISDEP,IGAUGE,IWIDCOR
      COMMON/GRCINIT3/IGSUB,IGPP,INPFL,ICOUP,IFACT,ISDEP,IGAUGE,IWIDCOR

      INTEGER KTYPE,CXTYPE,NNF,IPX
      COMMON/GRCINIT4/KTYPE,CXTYPE,NNF,IPX(10)

      INTEGER IGPCOMB
      COMMON/GRCINIT5/IGPCOMB(157)

C ibsint = 0 : Event Generation.
C        = 1 : Integration.
C
C ibswrt = 0 : Write output file.
C        = 1 : Already exist.
C
C irej   = 0 : Integration/Event Generation has succeeded.
C        > 0 :                                  failed.
C
C ktype : Kinematics Type.
C
C cxtype : Particle Combination Type.
C
C nnf     : Total Num. of particles considered in ME.
C ipx(8)  : Particle ID Num. depending on ktype and cxtype.
C
C irseed,nzz : Seed for random number using standalone mode.
C nfprt   : Print the number showing the status of BASES integration.
C
C grcecm  : CM Energy (GeV) (= sqrt(s)).
C funcmax : Maximum Value of Differencial Cross Section.
C grcsig  : Total Cross Section.
C igsub   : Process ID.
C igpp    : Collision particles PP/PAP. : pp/ppbar : 0/1
C inpfl   : Number of flavor from PDF. (Default = 4)
C
C icoup   : Set Energy Scale (Coupling Q^2).
C           if icoup = 1  ==> Q^2 = s^ for parton scale
C                    = 2  ==> Q^2 = average value of transverse mass^2
C                    = 3  ==> Q^2 = total transverse mass^2
C                    = 4  ==> Q^2 = maximum transverse mass^2
C                    = 5  ==> Q^2 = constant value
C                            (Set grcq in GeV order)
C                    = 6  ==> user defined Q^2 (set GRCUSRSETQ)
C           Note : if ifact = 0, Factorization scale is set 
C                  the same as the renormalization scale.
C
C ifact   : Choice of  the factorization scale.
C           if ifact = 0 ==> same as the renormalization scale. (see icoup)
C                    = 1  ==> Q^2 = s^ for parton scale
C                    = 2  ==> Q^2 = average value of transverse mass^2
C                    = 3  ==> Q^2 = total transverse mass^2
C                    = 4  ==> Q^2 = maximum transverse mass^2
C                    = 5  ==> Q^2 = constant value
C                            (Set grcfaq in GeV order)
C                    = 6  ==> user defined Q^2 (set GRCUSRSETQ)
C
C isdep = 1 : s^-dependence of the resonance production.
C
C#########################################
C###  Cut Parameter for Each Particle  ###
C#########################################
      DOUBLE PRECISION GRCPTCUT,GRCETACUT,GRCRCONCUT,GRCMETCUT
      COMMON/GRCCUT1/GRCPTCUT(8),GRCETACUT(8),GRCRCONCUT(8),GRCMETCUT
      DOUBLE PRECISION GPTCUT,GETACUT,GRCONCUT
      COMMON/GRCCUT2/GPTCUT,GETACUT,GRCONCUT

C Default ==> without any cuts
C 
C grcptcut(i)   : Pt cut for i-th Final State Particles.
C grcetacut(i)  : Eta cut for i-th Final State Particles.
C grcrconcut(i) : Rcone cut (= sqrt(dPhi(i,j)**2+dEta(i,j)**2)  j=1,2,3..).
C                                      for i-th Final State Particles.
C grcmetcut     : Missing Pt(Et) cut.
C
C gptcut        : Pt cut applied for all Final State Particles.
C getacut       : Eta cut applied for all Final State Particles.
C grconcut      : Rcone cut applied for all Final State Particles.

C####################################################################
C###  4-Momemtum of Each Particle and Differencial Cross Section  ###
C####################################################################
      DOUBLE PRECISION PGRC,PLGRC,PQGRC,GRCDSIG,GRCQ,GRCFAQ
      COMMON/GRCMON1/PGRC(4,10),PLGRC(4,10),PQGRC(4,6),GRCDSIG(32),
     $     GRCQ,GRCFAQ

      INTEGER GRCHLC
      COMMON/GRCMON2/GRCHLC(10)

C pgrc(4,i)  : 4-Momentum (px,py,pz,E) of i-th Particle.
C plgrc(4,i) : 4-Momentum (pt,phi,eta,E) of i-th Particle for Final State.
C                         (px,py,pz,E)                    for Initial.
C pqgrc(4,i) : 4-Momentum (px,py,pz,E) of intermediate Particle.
C grcdsig    : Differencial Cross Section.
C grcq       : Energy scale of the process (renormalization scale).
C grcfaq     : Factorization scale of the process.
C
C grchlc(i)  : Helicity state of i-th Particle.

C###################################################
C###  Initial Parameter of Kinematical Variable  ###
C###################################################
      DOUBLE PRECISION GTAU,GYST,GCOS3,GQ12,GQ22,GCON,GSPR,GEPS
      COMMON/GRCPAR1/GTAU(18),GYST(18),GCOS3(18),GQ12(18),GQ22(18),
     $               GCON(5),GSPR(5),GEPS(5)

C gtau(1),gyst(1),gcos3(1),gq12(1),gq22(1)
C           : Number of Function of Each Variable (Tau,Yst,Cos,Q12,and Q22).
C
C gtau(2),gyst(2),gcos3(2),gq12(2),gq22(2)
C           : Minimum Value of Each Variable.
C
C gtau(3-7),gyst(3-7),gcos3(3-7),gq12(3-7),gq22(3-7)
C           : Maximum Value of Each Function for Each Variable.
C
C gtau(8-13),gyst(8-13),gcos3(8-13),gq12(8-13),gq22(8-13)
C           : Maximum Region of Random Number for Each Function.
C
C gtau(14-18),gyst(14-18),gcos3(14-18),gq12(14-18),gq22(14-18)
C           : Function Type for Each Region.
C
C gcon : Cos Tunning Parameter.
C gspr : Subsystem Cosine Function Type.
C geps : Tunning Parameter of Subsystem Cosine Function.

C###############################
C###  Kinematical Variables  ###
C###############################
      DOUBLE PRECISION XRUN,GPRI,GVAL,YACOB
      COMMON/GRCFUNC/XRUN(32),GPRI(10),GVAL(32),YACOB

      INTEGER GRCFLAV,GRCIREG,GRCICOL,GRCIHEL
      COMMON/GRCFUNC1/GRCFLAV,GRCIREG,GRCICOL(8),GRCIHEL(8)

C grcflav : Flavor ID from proton/anti-proton.
C  _______________________
C | Initial |             |
C |  State  | gluon,gluon |
C +=========+=============+
C | grcflav |      0      |
C +---------+-------------+
C  _____________________________________________________________________
C | Initial |  _ |  _ |  _ |  _ | _  | _  | _  | _  |  _ | _  |  _ | _  |
C |  State  | uu | dd | cc | ss | uu | dd | cc | ss | bb | bb | tt | tt |
C +=========+====+====+====+====+====+====+====+====+====+====+====+====+
C | grcflav |  1 |  2 |  3 |  4 |  5 |  6 |  7 |  8 |  9 | 10 | 11 | 12 |
C +---------+----+----+----+----+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | uc | ds | cu | sd | uc | ds | cu | sd |
C           +====+====+====+====+====+====+====+====+
C           | 133| 134| 135| 136| 137| 138| 139| 140|
C           +----+----+----+----+----+----+----+----+
C b-content  _______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | db | sb | bd | bs | bd | bs | db | sb |
C           +====+====+====+====+====+====+====+====+
C           | 141| 142| 143| 144| 145| 146| 147| 148|
C           +----+----+----+----+----+----+----+----+
C top-content_______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | ut | ct | tu | tc | ut | ct | tu | tc |
C           +====+====+====+====+====+====+====+====+
C           | 149| 150| 151| 152| 153| 154| 155| 156|
C           +----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C |  State  | ud | cs | du | sc | ud | cs | du | sc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 |
C +---------+----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C |  State  | us | cd | su | dc | us | cd | su | dc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 21 | 22 | 23 | 24 | 25 | 26 | 27 | 28 |
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C           | ub | cb | bu | bc | ub | cb | bu | bc |
C           +====+====+====+====+====+====+====+====+
C           | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 |
C           +----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |    |    |    |    | _  | _  | _  | _  |
C |  State  | ug | dg | cg | sg | ug | dg | cg | sg |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 |
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    |  _ |  _ |  _ |  _ |
C           | gu | gd | gc | gs | gu | gd | gc | gs |
C           +====+====+====+====+====+====+====+====+
C           | 45 | 46 | 47 | 48 | 49 | 50 | 51 | 52 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    | _  |    |  _ |    | _  |    |  _ |
C           | bg | bg | gb | gb | tg | tg | gt | gt |
C           +====+====+====+====+====+====+====+====+
C           | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 |
C           +----+----+----+----+----+----+----+----+
C  _____________________________________________________________________
C | Initial |    |    |    |    | __ | __ | __ | __ |    | __ |    | __ |
C |  State  | uu | dd | cc | ss | uu | dd | cc | ss | bb | bb | tt | tt |
C +=========+====+====+====+====+====+====+====+====+====+====+====+====+
C | grcflav | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 |
C +---------+----+----+----+----+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | uc | ds | cu | sd | uc | ds | cu | sd |
C           +====+====+====+====+====+====+====+====+
C           | 73 | 74 | 75 | 76 | 77 | 78 | 79 | 80 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | bd | bs | db | sb | bd | bs | db | sb |
C           +====+====+====+====+====+====+====+====+
C           | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | tu | tc | ut | ct | tu | tc | ut | ct |
C           +====+====+====+====+====+====+====+====+
C           | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 |
C           +----+----+----+----+----+----+----+----+
C
C subroutine grcprtnqqs
C  _________________________________________________
C | Initial |    |    |    |    |    |    |    |    |
C |  State  | ud | us | cd | cs | du | dc | su | sc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 97 | 98 | 99 | 100| 101| 102| 103| 104|
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           | __ | __ | __ | __ | __ | __ | __ | __ |
C           | ud | us | cd | cs | du | dc | su | sc |
C           +====+====+====+====+====+====+====+====+
C           | 105| 106| 107| 108| 109| 110| 111| 112|
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | ub | cb | bu | bc | ub | cb | bu | bc |
C           +====+====+====+====+====+====+====+====+
C           | 113| 114| 115| 116| 117| 118| 119| 120|
C           +----+----+----+----+----+----+----+----+
C            ___________________________________________________________
C           |    |    |    |    |    |    | __ | __ | __ | __ | __ | __ |
C           | td | ts | tb | dt | st | bt | td | ts | tb | dt | st | bt |
C           +====+====+====+====+====+====+====+====+====+====+====+====+
C           | 121| 122| 123| 124| 125| 126| 127| 128| 129| 130| 131| 132|
C           +----+----+----+----+----+----+----+----+----+----+----+----+
C
C grcireg : Swich parameter for phase space.
C grcicol : Color State for Color String of PYTHIA.
C
C xrun : Random Number for Integration and Event Generation.
C        if init = 1   ==> Integration
C                = 2   ==> Event Generation
C
C gpri : Most Primitive Variables for All Processes.
C            gpri(1)  : tau (= x1*x2)           using xrun(1)
C            gpri(2)  : yst (= 0.5*log(x1/x2))        xrun(2)
C            gpri(3)  : s^ (= (E1 + E2)^2)
C            gpri(4)  : w^ (= sqrt(s^))
C            gpri(5)  : x1 from particle 1 side
C            gpri(6)  : x2 from particle 2 side
C            gpri(7)  : beta
C            gpri(8)  : gamma
C            gpri(9)  : energy scale (in GeV order)
C            gpri(10) : Random Number to decide Initial Flavor
C                             using xrun(Last Num. of NDIM ==> see grcpar.f)
C
C gval : Kinematical Variables for Each Processes.
C
C yacob : Jacobian of Phase Space.

C#####################
C###  Decay Table  ###
C#####################
      INTEGER IGZMOD,IGWMOD,IGZDCY,IGWDCY,IGJFLV
      COMMON/GRCDCY1/IGZMOD(16),IGWMOD(20),IGZDCY(32),IGWDCY(40),
     $               IGJFLV(8)

      DOUBLE PRECISION GAMS,GRCZBR,GRCWBR,GRCCKM
      COMMON/GRCDCY2/GAMS(16),GRCZBR(16),GRCWBR(20),GRCCKM(4,4)

      INTEGER IGNDCY,GDCYPR1,GDCYPR2
      COMMON/GRCIDCY/IGNDCY,GDCYPR1(400),GDCYPR2(400)

      DOUBLE PRECISION GDCYSUM,GDCYRAT
      COMMON/GRCDDCY/GDCYSUM,GDCYRAT(400)

      INTEGER IGRCGEF
      COMMON/GRCFDCY/IGRCGEF

      DOUBLE PRECISION F0,F1,F2
      COMMON/GRCTDCY/F0,F1,F2

C igzdcy/igwdcy   : KF codes of Z/W decay products.
C igjflv          : Activate on jet flavor : ON/OFF:1/0, for d/u/s/c/b/t/g. 
C gwdcyms         : Masses of W decay products, only valid for 4-body ME.
C grczbr/grcwbr   : Br. ratio of Z/W.
C grcckm          : CKM matrix.
C igndcy          : Number of allowed-decay mode of W and Z.
C gdcypr1/gdcypr2 : Allowed decay mode.
C gdcysum         : Summation of allowed decay Br. ratio.
C gdcyrat         : Ratio for allowed decay Br. ratio.
C igrcgef         : include photon interference in Z propagation, ON/OFF:1/0.

C#########################
C###  Check Parameter  ###
C#########################
      INTEGER INBS,INKV,INKC,IN4M,INAC
      COMMON/GRCCHK/INBS,INKV,INKC,IN4M,INAC

C inbs : Status Number of Integration
C inkv : Failed to set Kinematical Variables
C inkc : Failed to pass Kinematical Cuts
C in4m : Failed to set 4-momemtum for each particle
C inac : Failed Additional Constraint

C######################
C###  Advanced Use  ###
C######################
      real*8 signedres
      integer matching,ishower,labcut
      common /advance/signedres,matching,ishower,labcut

C signedres: signed matrix-element result
C            An absolute value is returned to BASES/SPRING when negative 
C            results are not supported.
C            The event weight (+1 or -1) can be determined by referring to
C            this variable.
C matching: flag for the radiation matching
C           = 1 LLL subtraction is applied to jet-production processes.
C ishower: flag for PS in GR@PPA
C          = 1 Kurihara's QCDPS for the initial state.
C labcut: flag to activate the "LabCut"
C         = 1 events to generate are composed and a cut is applied in "func"
